## org.junit.rules
Class DisableOnDebug

    java.lang.Object
      org.junit.rules.DisableOnDebug

All Implemented Interfaces:
  TestRule

    public class DisableOnDebug

extends Object
implements TestRule

The `DisableOnDebug` Rule allows you to label certain rules to be disabled when debugging.

The most illustrative use case is for tests that make use of the `Timeout` rule, when ran in debug mode the test may terminate on timeout abruptly during debugging. Developers may disable the timeout, or increase the timeout by making a code change on tests that need debugging and remember revert the change afterwards or rules such as `Timeout` that may be disabled during debugging may be wrapped in a `DisableOnDebug`.

The important benefit of this feature is that you can disable such rules without any making any modifications to your test class to remove them during debugging.

This does nothing to tackle timeouts or time sensitive code under test when debugging and may make this less useful in such circumstances.

Example usage:

     public static class DisableTimeoutOnDebugSampleTest {

         @Rule
         public TestRule timeout = new DisableOnDebug(new Timeout(20));

         @Test
         public void myTest() {
             int i = 0;
             assertEquals(0, i); // suppose you had a break point here to inspect i
         }
     }

Since:
  4.12

Constructor Summary
`DisableOnDebug(TestRule rule)` Create a `DisableOnDebug` instance with the timeout specified in milliseconds.

Method Summary
`Statement` `apply(Statement base, Description description)` Modifies the method-running `Statement` to implement this test-running rule.
`boolean` `isDebugging()` Returns `true` if the JVM is in debug mode.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DisableOnDebug

    public DisableOnDebug(TestRule rule)

  Create a `DisableOnDebug` instance with the timeout specified in milliseconds.

  Parameters:
    `rule` - to disable during debugging

Method Detail

### apply

    public Statement apply(Statement base,
                           Description description)

  Description copied from interface: `TestRule`
  Modifies the method-running `Statement` to implement this test-running rule.

  Specified by:
    `apply` in interface `TestRule`
  Parameters:
    `base` - The `Statement` to be modified
    `description` - A `Description` of the test implemented in `base`
  Returns:
    a new statement, which may be the same as `base`, a wrapper around `base`, or a completely new Statement.
  See Also:
    `TestRule.apply(Statement, Description)`

### isDebugging

    public boolean isDebugging()

  Returns `true` if the JVM is in debug mode. This method may be used by test classes to take additional action to disable code paths that interfere with debugging if required.

  Returns:
    `true` if the current JVM is in debug mode, `false` otherwise

Copyright © 2002–2020 JUnit. All rights reserved.